//
//  ViewGLBase.h
//  ChocoFlopX
//
//  Created by Santiago Lema on 26.09.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#import <OpenGL/glext.h>


@interface ViewGLBase : NSOpenGLView 
{

	NSLock* forceRenderLock;
	NSOpenGLPixelFormat *pFormat;
	CIContext *_context;
	NSDictionary* _contextOptions;

//	NSMutableDictionary* pBufferTiles;
//	NSMutableDictionary* contextTiles;
//	NSMutableDictionary* cicontextTiles;
	
	NSLock* renderAddOpenGLZoneLock;
	NSMutableArray* rectsToRenderOpenGL;
	NSLock* openGLLock;

	CGRect docFrame;
	CIFormat docCIFormat;
	float docWBefore, docHBefore;

	CGPoint   viewOffset;
	float     zoomLevel;
    NSRect    _lastBounds;
	float _lastZoomLevel;


	//TODO hardcoded max textures. .bad idea but a good margin
	//64*64 textures of 256x256 textures is 16384x16384 max
	//64x64 = 4096 textures
//	GLuint textures[4096*8];     // texture ID
//	BOOL texturesExist[4096*8];     
//	BOOL texturesUpdating[4096*8];     
//	int  texturesUpdated[4096*8];
//	int  texturesWidth[4096*8];
//	int  texturesHeight[4096*8];
//	int nbTextures, textureTilesX,textureTilesY;
	
}

//--------------------
//OBJC C functions
//--------------------

//-(int)getNextTextureTileForSize: (int) left;
//-(void)clearAllTextures;
//-(BOOL) updateTexturesSettings;
//-(BOOL) updateOpenGLTexture: (CIImage*) ciimg zone:(CGRect)zone;

- (CGRect)getDocFrame;
- (void)setDocFrame:(CGRect)r;

- (CIFormat)getDocCIFormat;
- (void)setDocCIFormat:(CIFormat)r;

//The methods are only used in the overloaded PaintView
- (void)setOffset:(CGPoint)offsetPoint;
- (CGPoint)getOffset;


-(NSDictionary*) getContextOptions;
-(void ) createOGLContext;
-(NSOpenGLPixelFormat*) getMyPixelFormat;

//-(NSOpenGLPixelBuffer*) getPBufferForTile:(int)textureID withWidth: (int)width andHeight:(int) height;
//-(NSOpenGLContext*) getTextureContextForTile:(int)textureID withPixelBuffer: (NSOpenGLPixelBuffer*) ogl_pBuffer;
//-(CIContext*) getTextureCIContextForTile:(int)textureID withGLContext:(NSOpenGLContext*)glcon;

- (void)viewBoundsDidChange:(NSRect)bounds;
//-(BOOL) getUseCoreImageToZoom;

-(void) refreshImageWithCorrection:(CGRect)rectPaint;
-(CGRect) getZoomedRect;
-(void) setNeedsDisplayInCorrectThread;
-(void) setNeedsDisplayInCorrectThreadForRect:(CGRect)r;
-(CIContext*) getContext;

//--------------------
//PLAIN C functions
//--------------------

void drawOval (float x_center, float y_center, float w, float h, int n);
void drawEmptyGLRect(float x1, float y1, float x2, float y2);
void drawInvertedGLRect(float x1, float y1, float x2, float y2);
void drawBorderedGLRect(float x1, float y1, float x2, float y2);

#define TWOPI           6.283185307179586476925287
#define PI              3.141592653589793238462643


@end
